# PhasicFlow: iEntry Class Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

iEntry Class Referenceabstract

Interface calss for data entry and dictionary
More...

Inheritance diagram for iEntry:
[legend]

## Public Member Functions

| TypeInfo ("iEntry")
| Type info. More...
| iEntry ()
| empty constructor More...
| iEntry (const word &key)
| construct with a keyword More...
virtual | ~iEntry ()
| destructor More...
virtual const word & | keyword () const
| return keyword More...
virtual word & | keyword ()
| return keyword More...
virtual word | name () const
| name/keyword of entry More...
virtual word | globalName () const =0
virtual dictionary * | dictPtr ()
| pointer to this dictionary More...
virtual const dictionary * | dictPtr () const
| const pointer to this dictionary More...
virtual bool | isDictionary () const
| if this is a dictionary More...
virtual const dictionary & | parrentDict () const =0
| const ref to parrent dictionary More...
virtual dictionary & | dict ()=0
| ref to this dictionary, if it is a dictionary More...
virtual const dictionary & | dict () const =0
| const ref to this dictionary, if it is a dicrionary More...
virtual iEntry * | clonePtr () const =0
| clone the object More...
virtual uniquePtr< iEntry > | clone () const =0
virtual iEntry * | clonePtr (const dictionary &parDict) const =0
| clone the object and change its ownership to parDict More...
virtual uniquePtr< iEntry > | clone (const dictionary &parDict) const =0
| clone the object and change its ownership to parDict More...
virtual bool | read (iIstream &is)=0
| read from stream More...
virtual bool | write (iOstream &os) const =0
| write to stream More...

## Static Public Member Functions

static bool | readKeyword (iIstream &is, word &keyword, token &tok)
| read a keyword from stream More...
static bool | createEntry (dictionary &parDict, iIstream &is, bool hasBlockToken=false)
| create an entry (dataEntry or dictionary) from stream More...

## Protected Member Functions

bool | writeKeyword (iOstream &os) const

## Protected Attributes

word | keyword_

## Detailed Description

Interface calss for data entry and dictionary

Definition at line 42 of file iEntry.hpp.

## Constructor & Destructor Documentation

## iEntry() [1/2]

iEntry | ( |  | ) |

inline

empty constructor

Definition at line 70 of file iEntry.hpp.

## iEntry() [2/2]

iEntry | ( | const word & | key | ) |

inline

construct with a keyword

Definition at line 74 of file iEntry.hpp.

## ~iEntry()

virtual ~iEntry | ( |  | ) |

inlinevirtual

destructor

Definition at line 81 of file iEntry.hpp.

## Member Function Documentation

## readKeyword()

bool readKeyword | ( | iIstream & | is,
|  | word & | keyword,
|  | token & | tok
| ) |  |

static

read a keyword from stream

Definition at line 32 of file iEntry.cpp.

## createEntry()

bool createEntry | ( | dictionary & | parDict,
|  | iIstream & | is,
|  | bool | hasBlockToken = `false`
| ) |  |

static

create an entry (dataEntry or dictionary) from stream

Definition at line 64 of file iEntry.cpp.

## writeKeyword()

bool writeKeyword | ( | iOstream & | os | ) | const

protected

Definition at line 154 of file iEntry.cpp.

## TypeInfo()

TypeInfo | ( | "iEntry" |  | ) |

Type info.

## keyword() [1/2]

virtual const word& keyword | ( |  | ) | const

inlinevirtual

return keyword

Definition at line 88 of file iEntry.hpp.

Referenced by dictionary::add(), dictionary::addOrKeep(), dictionary::getValOrSetMax(), dictionary::getValOrSetMin(), and iEntry< Key, T * >::name().

Here is the caller graph for this function:

## keyword() [2/2]

virtual word& keyword | ( |  | ) |

inlinevirtual

return keyword

Definition at line 94 of file iEntry.hpp.

## name()

virtual word name | ( |  | ) | const

inlinevirtual

name/keyword of entry

Definition at line 100 of file iEntry.hpp.

Referenced by baseShapeNames::indexToShapeName(), property::material(), property::nameToIndex(), Wall::readCommon(), Time::readDictionary(), baseShapeNames::shapeNameToIndex(), shape::shapeNameToPropId(), and countField::variableName().

Here is the caller graph for this function:

## globalName()

virtual word globalName | ( |  | ) | const

pure virtual

Implemented in dictionary, and dataEntry.

## dictPtr() [1/2]

virtual dictionary* dictPtr | ( |  | ) |

inlinevirtual

pointer to this dictionary

Reimplemented in dictionary, and dataEntry.

Definition at line 109 of file iEntry.hpp.

## dictPtr() [2/2]

virtual const dictionary* dictPtr | ( |  | ) | const

inlinevirtual

const pointer to this dictionary

Reimplemented in dictionary, and dataEntry.

Definition at line 115 of file iEntry.hpp.

## isDictionary()

virtual bool isDictionary | ( |  | ) | const

inlinevirtual

if this is a dictionary

Reimplemented in dictionary, and dataEntry.

Definition at line 121 of file iEntry.hpp.

## parrentDict()

virtual const dictionary& parrentDict | ( |  | ) | const

pure virtual

const ref to parrent dictionary

Implemented in dictionary, and dataEntry.

## dict() [1/2]

virtual dictionary& dict | ( |  | ) |

pure virtual

ref to this dictionary, if it is a dictionary

Implemented in dictionary, and dataEntry.

## dict() [2/2]

virtual const dictionary& dict | ( |  | ) | const

pure virtual

const ref to this dictionary, if it is a dicrionary

Implemented in dictionary, and dataEntry.

## clonePtr() [1/2]

virtual iEntry* clonePtr | ( |  | ) | const

pure virtual

clone the object

Implemented in dictionary, and dataEntry.

## clone() [1/2]

virtual uniquePtr<iEntry> clone | ( |  | ) | const

pure virtual

Implemented in dictionary, and dataEntry.

Referenced by dictionary::dictionary().

Here is the caller graph for this function:

## clonePtr() [2/2]

virtual iEntry* clonePtr | ( | const dictionary & | parDict | ) | const

pure virtual

clone the object and change its ownership to parDict

Implemented in dictionary, and dataEntry.

## clone() [2/2]

virtual uniquePtr<iEntry> clone | ( | const dictionary & | parDict | ) | const

pure virtual

clone the object and change its ownership to parDict

Implemented in dictionary, and dataEntry.

## read()

virtual bool read | ( | iIstream & | is | ) |

pure virtual

read from stream

Implemented in dictionary, and dataEntry.

Referenced by pFlow::operator>>().

Here is the caller graph for this function:

## write()

virtual bool write | ( | iOstream & | os | ) | const

pure virtual

write to stream

Implemented in dictionary, baseShapeNames, and dataEntry.

Referenced by pFlow::operator<<().

Here is the caller graph for this function:

## Member Data Documentation

## keyword_

word keyword_

protected

Definition at line 58 of file iEntry.hpp.

Referenced by iEntry< Key, T * >::iEntry(), and iEntry< Key, T * >::keyword().

The documentation for this class was generated from the following files:

- src/phasicFlow/dictionary/entry/iEntry.hpp
- src/phasicFlow/dictionary/entry/iEntry.cpp